/**
  *********************************************************************************
  * @file    	    touch.h
  * @author  	    FMD AE
  * @brief   	    ͷļ
  * @version 	    V2.0.1          
  * @data		    2022-03-25
  *********************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  *Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  **********************************************************************************
  */  

  /**********************************************************************************
  * @оƬԴ
  * 1. Device: FT62F13X
  * 2. Memory: Flash 3KX14b, SRAM:256X8b EEPROM 128X8b 
  *
  * @ʹԴ˵:
  * 1 .TIMER0TIMER1
  * 2. LVDж
  * 3. ROM & SARM (key = 1,led.c)  
  *                  ROM *14b      SRAM*8b
  *     touch.lpp          397+3*key	 15+2*key
  * 4. SRAMַָ:
  **********************************************************************************
  */
 
#ifndef _TOUCH_H
#define _TOUCH_H

///////////ͷļ/////////////////////////////////////
#include <string.h>
#include "SYSCFG.h"

/////////////ϵͳʱ///////////////////////////////////////////
#define SYS_OSCCON   0B01110001

/////////ӦоƬKEYIOӳ䶨//////////////////////////
#define   KEY0_INDEX_MAP       7
#define   KEY1_INDEX_MAP       6
#define   KEY2_INDEX_MAP       5
#define   KEY3_INDEX_MAP       4
#define   KEY4_INDEX_MAP       2
#define   KEY5_INDEX_MAP       3
#define   KEY6_INDEX_MAP       0
#define   KEY7_INDEX_MAP       1

#define   KEY_NUMBER   8  //Ŀǰ8
const unsigned char ucKeyNumberMax = KEY_NUMBER;
unsigned int uiTkData[KEY_NUMBER]; 

const unsigned char ucKeyIndexMapArray[KEY_NUMBER]=
{
    KEY0_INDEX_MAP,
    KEY1_INDEX_MAP,
    KEY2_INDEX_MAP,
    KEY3_INDEX_MAP,
    KEY4_INDEX_MAP,
    KEY5_INDEX_MAP,
    KEY6_INDEX_MAP,
    KEY7_INDEX_MAP
};

///////////ܺ/////////////////////////////////////
void TOUCH_INITIAL(void);  //óʼ          
void TSC_Start(void);      //ɨÿֻһһɨ账
unsigned char TSC_Sampling(void);//а״̬: 1ʾаɣ0ʾδ    
unsigned int TSC_GetSmpleData(unsigned char keyNum);//ȡӦİݣɺſʹ
#endif
