/**
  *********************************************************************************
  * @file    	    main.c
  * @author  	    FMD AE
  * @brief   	    Device: FT62F28X
  *                 Memory: Flash 8KX14b, EEPROM 128X8b, SRAM 616X8b
  *                 touchʹʾ	
  * @version 	    V2.0.1           
  * @data		    2022-04-08
  *********************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  *Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  **********************************************************************************
*/

//===========================================================
//include definition
//===========================================================
#include	"SYSCFG.h";
#include	"touch.h";
#include	"led.h";

//===========================================================
//Variable definition
//===========================================================
unsigned char strongest = 0; //demo_test
unsigned char Sav_strongest = 0; //demo_test

unsigned char temp = 0;

/******************************************************************************
  * @brief  DelayUs program
  * @Description  ʱ
  * @param  time
  * @note   
  * @retval  None
  *****************************************************************************
*/

void DelayUs(unsigned int Time)
{    
	unsigned int a;
	for(a=0;a<Time;a++)
	{
		NOP();
	}
}

/******************************************************************************
  * @brief  interrupt ISR	program
  * @Description  жں עBANKл
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void interrupt ISR(void) 
{ 
		//жʱbank
		if(AUXPGE==0) //BANK0-3
		{
			temp = 0;
		}
		else
		{
			AUXPGE = 0;
			temp = 1;
		}   
        		
        
        //жʱbankָ
		if(AUXPGE==0)//BANK0-3
		{
			AUXPGE = temp ;
		}
		else
		{
			AUXPGE = 0;
			AUXPGE = temp ;
		}
} 

/******************************************************************************
  * @brief  SYS_INITIAL	program
  * @Description  ϵͳʱӡIOʼ
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void SYS_INITIAL (void) 
{
	 
	OSCCON = SYS_OSCCON;//0B01110001;    //WDT 32KHZ IRCF=110=16MHZ/4=4MHZ,0.25US/T
							//Bit0=1,ϵͳʱΪڲ
							//Bit0=0,ʱԴFOSC<20>ѡʱѡ
                            
	OPTION = 0B00001000;	//Bit3 PSA   ԤƵλ 0= ԤƵTimer0ģ 1WDT 
							//Bit20ԤƵѡλ 000: 1:2 
                            
    INTCON = 0;  			//ݽֹж
    
	PORTA = 0;
	PORTB = 0;
    PORTD = 0;
    PORTC = 0;
    
	TRISA =  0B00000000;	// 0- 1-     RA4 -
    TRISB =  0B00000000;	// B4-B7  TK5-TK2    PB7--touch
    TRISC =  0B00000000;
    TRISD =  0B00100000;	// TKCAP PD5
//	TRISD =  0B00100100;	// TKCAP PD5  //PD2 ңĻеIO
    
    ANSEL1 = 0B10000000;     // TKCAP D2Ϊģ		
    
	BANKSEL4_7;
	WPUA =  0B00000000;     //PA˿ 1- 0-
    WPUB =  0B00000000;
	WPUC =  0B00000000;
	WPUD =  0B00000000;
	WPDA =  0B00000000;     //PA˿ 1- 0-
    WPDB =  0B00000000;
	WPDC =  0B00000000;
	WPDD =  0B00000000;   
    BANKSEL0_3;		   
}

/******************************************************************************
  * @brief  WDT_INITIAL	program
  * @Description  ʼÿŹΪ16λSLEEPģʽ128ms
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void WDT_INITIAL (void) 
{
	CLRWDT();     			//忴Ź
	WDTCON = 0B00001111;    //bit[6:5]WCKSRC=00=LIRC(32K) 
							//bit[4:1]WDTPS=0110=1:4096,ԤƵ1:1 ʱʱ=(4096*1)/32000=128ms  
							//bit[0]SWDTEN= 1                       	                  
}

/**********************************************************************************
  * @brief  Sleep_Enable  program.
  * @param  None
  * @note   ˯ߵش
  * @retval None
  *********************************************************************************
*/
void Sleep_Enable(void)
{ 
   if(bSleepMode == 1)
   {
         bSleepMode = 0;
       
//////////͹Ĵ޸///////////////////////
         TKON = 0; //Ĵ	       		//2CLK    
         TKEN0 = 0; //رհͨĴ     	//1CLK
         TKEN1 = 0; //رհͨĴ      	//1CLK
         TKEN2 = 0; //رհͨĴ      	//2CLK
         TKEN3 = 0; //رհͨĴ      	//1CLK 
         LVDEN = 0; //رLVD⹦    		//3CLK      
         T0CON0 = 0x01; //رT0CKRUN        	//1CLK 
         ///////////////////////////////               
		 SLEEP();  //˯	  				//1CLK                  
         ///////////////////////////////                
         T0CON0 = 0x05; //T0CKRUN           //1CLK      
         LVDEN = 1; //LVD⹦           //3CLK               
         bSleepScanEnable = 1; //˯ɨ     //2CLK       
//////////͹Ĵ޸///////////////////////

	}
}

/******************************************************************************
  * @brief  main	program
  * @Description 
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void main(void )
{
    SYS_INITIAL ();//ϵͳʱӡIOʼ   
    //////////////////////////////////////////////////
    //touchԴʹ뿴touch.h˵
    TOUCH_INITIAL();//ʼ
    //͹Ķʱر 
	WDT_INITIAL(); //Źʼ
    //////////////////////////////////////////////////
    PEIE = 1;  //ʹж
	GIE = 1;  //ʹȫж
    
    LED(); //led.c  demo_test
    
 	////͹Ĵ־////////////////////
    bSleepUserFlag = 1;   //Ϊ1ʾɽ͹ģûʹ־ǷҪ͹״̬
    bSleepUserWakeFlag = 0; //Ϊ1ʾǿ˳͹ģûʹ־Ƿǿ˳ͺ
    ////͹Ĵ־////////////////////
    
//	//////demo_test/////////////////////
//	TRISC |= 0B00000001; //PC0Ϊ
//    //////demo_test/////////////////////
    
    while (1)
    {
		//忴Ź   
	    CLRWDT();  
//////////͹Ĵ޸///////////////////////
        if(bSleepScanEnable == 1)
        {
//            //////demo_test/////////////////////
//            if(PC0==1)//⵽PC0ߵƽbSleepUserWakeFlag1
//            {
//                bSleepUserWakeFlag = 1; //Ϊ1ʾǿ˳͹ģûʹ־Ƿǿ˳ͺ
//            }
            //////demo_test/////////////////////
            
            if(TSC_SleepPrcoessing()==1) //˳͹ģʽ  bSleepUserWakeFlag=1ǿ˳͹
            {
                GIE = bIEBackupsFlag;
				bSleepUserWakeFlag = 0; //ǿƻѱ־
                 
                //////--start--˳͹ģʽûԶ崦/////                
				//ûԶ崦
                //////--end---˳͹ģʽûԶ崦/////
            }   																	
        }
        else
//////////͹Ĵ޸///////////////////////
        {  
            //ɨ
            TSC_Start(); 
            
			if(TSC_DataProcessing()== 1) //1ʾаһΡ
			{
				//////demo_test/////////////////////
				strongest = TSC_GetStrongest();
				if(Sav_strongest != strongest)
				{
					LED_Scan(); //led.c  µӦled                   
				}
				Sav_strongest = strongest;
				//////demo_test/////////////////////
                
				if(bSleepMode == 1) //1ΪʾҪ͹
                {          
					 bIEBackupsFlag = GIE;  
					 GIE = 0;	  
					 ////start--͹ûԶ崦////////////////////			
					 
					 ////end---͹ûԶ崦/////////////////////             
                }  
			}
            
        }
                		
//////////͹Ĵ޸////////////////////////////////////////
        Sleep_Enable();       
//////////͹Ĵ޸///////////////////////////////////////
        
    }     
    
}

//===========================================================
