/**
  **************************************************************************************************************
  * @file    	    touch.h
  * @author  	    FMD AE
  * @brief   	    ͷļ
  * @version 	    V2.0.1           
  * @data		    2022-04-08
  **************************************************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  *Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  ***************************************************************************************************************
  */  
  
/****************************************************************************************************************
  * @оƬԴ
  * 1. Device: FT62F28X
  * 2. Memory: Flash 8KX14b, EEPROM 128X8b, SRAM 616X8b
  * @ʹԴ˵:
  * 1. TIMER0TIMER1
  * 2. LVDж
  * 3. ROM & SARM (K = 1,Ks = 1led.c)  
  *                 		ROM *14b      	 SRAM*8b
  *  touch_soft.lpp		1,570+2*K		56+8*K
  *  touch.lpp		1,551+2*K		60+8*K
  *  touch_cs_ac.lpp		1,757+3*K		68+8*K
  *  touch_cs_uac.lpp		1,849+3*K		70+8*K
  *  touch_csf_ac.lpp		2,120+3*K		92+8*K
  *  touch_csf_uac.lpp	2,227+3*K		96+8*K
  *  touch_lp.lpp		2,166+2*K		68+8*K+2*Ks
  *  touch_cs_lp_ac.lpp	2,423+3*K		73+8*K+2*Ks
  *  touch_cs_lp_uac.lpp	2,482+3*K		76+8*K+2*Ks
  *  touch_csf_lp_ac.lpp	2,771+3*K		98+8*K+2*Ks
  *  touch_csf_lp_uac.lpp	2,864+3*K		102+8*K+2*Ks
  *
  * 4.SRAMַָ:
  *	 ַָ Ӧö壺0x200x210x72 ~ 0x79
  * 	ָչַ ݱ8BYTE/ 
  *	0x220~0x220+8*K							K :1~8
  *	0x220~0x25F0x2A0~0x2A0+8*(K-8					K : 9~16
  *	0x220~0x25F0x2A0 ~ 0x2DF0x320~0x320+8*(K-16)			K : 17~24
  *	0x220~0x25F0x2A0 ~ 0x2DF0x320 ~ 0x35F0x3A0~0x3A0+8*(K-24) 		K : 25~28
  ***************************************************************************************************************
  */  
  
#ifndef _TOUCH_H
#define _TOUCH_H

///////////ͷļ/////////////////////////////////////
#include <string.h>
#include "SYSCFG.h"

/////////ϵͳʱӶ//////////////////////////////////////
#define SYS_OSCCON   0B01110001 //16M

/////////ӦоƬKEYIOӳ䶨//////////////////////////
#define   KEY0_INDEX_MAP       	3
#define   KEY1_INDEX_MAP       	4
#define   KEY2_INDEX_MAP       	5
#define   KEY3_INDEX_MAP       	6
#define   KEY4_INDEX_MAP       	7
#define   KEY5_INDEX_MAP       	8
#define   KEY6_INDEX_MAP      	9
#define   KEY7_INDEX_MAP       	10
#define   KEY_NUMBER            8  //
const unsigned char ucKeyNumberMax = KEY_NUMBER;
const unsigned char ucKeyIndexMapArray[KEY_NUMBER]=
{
    KEY0_INDEX_MAP,
    KEY1_INDEX_MAP,
    KEY2_INDEX_MAP,
    KEY3_INDEX_MAP,
    KEY4_INDEX_MAP,
    KEY5_INDEX_MAP,
    KEY6_INDEX_MAP,
	KEY7_INDEX_MAP
};
/////////////Чֵ////////////////////////////////////
#define   KEY0_ON					17
#define   KEY1_ON					16
#define   KEY2_ON					16
#define   KEY3_ON					15
#define   KEY4_ON					16
#define   KEY5_ON					15
#define   KEY6_ON					16
#define   KEY7_ON					16
const unsigned char ucActiveSensorDeltaArray[KEY_NUMBER]=
{
 KEY0_ON,  KEY1_ON,  KEY2_ON,  KEY3_ON,  KEY4_ON,  KEY5_ON,  KEY6_ON,  KEY7_ON
};
///////////Чֵ//////////////////////////////////////
#define   KEY0_OFF					10
#define   KEY1_OFF					10
#define   KEY2_OFF					10
#define   KEY3_OFF					9
#define   KEY4_OFF					10
#define   KEY5_OFF					9
#define   KEY6_OFF					10
#define   KEY7_OFF					10
const unsigned char ucInActiveSensorDeltaArray[KEY_NUMBER]=
{
 KEY0_OFF,  KEY1_OFF,  KEY2_OFF,  KEY3_OFF,  KEY4_OFF,  KEY5_OFF,  KEY6_OFF,  KEY7_OFF
};

//////////״̬CSģʽµж///////////////////////////////////////////
#define RESONANCE_CHANGER_FREQ_COUNT_FILTER     1000   //CSʱ
const unsigned int uiResonanceChangerFreqCountFilter = RESONANCE_CHANGER_FREQ_COUNT_FILTER;	
#define RESONANCE_DATA_FILTER                   10    //CSж
const unsigned char ucResonanceDataFilter = RESONANCE_DATA_FILTER;
////////CS״̬¶///////////////////////////////////////////////////////////////
#define ABNORMAL_WAIT_COUNT_FILTER              1000 	//쳣״̬¶Чʱ
const unsigned int uiAbnormalWaitCountFilter = ABNORMAL_WAIT_COUNT_FILTER;	
#define NORMAL_COUNT_FILTER                     200  	//жϴ200ξͻָģʽ
const unsigned char ucNormalCountFilter = NORMAL_COUNT_FILTER;
#define ABNORMAL_COUNT_FILTER                   3   	//쳣жϴ3ξͽCSģʽ
const unsigned char ucAbnormalCountFilter = ABNORMAL_COUNT_FILTER;
#define KEY_OFF_ABNORMAL_UP_FILTER              5  		//ǰֵ쳣ֵ
const unsigned char ucKeyOffAbnormalUpFilter = KEY_OFF_ABNORMAL_UP_FILTER;
#define KEY_ON_ABNORMAL_UP_FILTER            	5 		//ֵ쳣
const unsigned char ucKeyOnAbnormalUpFilter = KEY_ON_ABNORMAL_UP_FILTER;
#define KEY_ON_ABNORMAL_DOWN_FILTER             15 		//ֵ쳣
const unsigned char ucKeyOnAbnormalDownFilter = KEY_ON_ABNORMAL_DOWN_FILTER;
////////ɨ///////////////////////////////////////////
#define SCAN_EFF_KEY_NUM           4 //鲻Ҫ޸
const unsigned char ucKeyScanEffNumber = SCAN_EFF_KEY_NUM;
unsigned char ucKeyScanBuffer[SCAN_EFF_KEY_NUM]; 
unsigned char ucKeyScanIndexBuffer[SCAN_EFF_KEY_NUM];

//////////ɼݴض///////////////////////////////////////////
#define MULTIPLE_1   							80    	//Ŵ
#define STRONG_FILTER_1   						4		//˲
#define SINGLE_FILTER_1  						4		//˲
#define BASE_LINE_DOWN_SPEED_1   				64    	//¸ٶ
#define BASE_LINE_UP_SPEED_1  					64	    //ϸٶ
#define BASE_LINE_EQUAL_UP_SPEED_1   			100		//Ͽٸ
#define BASE_LINE_EQUAL_DOWN_SPEED_1   		    200		//¿ٸ
#define SIGNAL_NOISE_RATIO_1  					30  	//
#define MEANTIME_MAX_KEY_NUM_1  		   	 	KEY_NUMBER  
const unsigned char ucMultiple = MULTIPLE_1;
const unsigned char ucStrongFilter = STRONG_FILTER_1;
const unsigned char ucSingleFilter = SINGLE_FILTER_1;
const unsigned char ucBaselineDownSpeed = 128 + BASE_LINE_DOWN_SPEED_1;
const unsigned char ucBaselineUpSpeed = 128 - BASE_LINE_UP_SPEED_1;
const unsigned char ucBaselineEqualUpSpeed = BASE_LINE_EQUAL_UP_SPEED_1;
const unsigned char ucBaselineEqualDownSpeed = BASE_LINE_EQUAL_DOWN_SPEED_1;
const unsigned char ucSignalNoiseRatio = SIGNAL_NOISE_RATIO_1;	
const unsigned char ucMeantimeMaxKeyNum = MEANTIME_MAX_KEY_NUM_1;

////////Ƶ΢///////////////////////////////////////////////////
#define FREQ_CHANGER_1_L 						0X00		//ɨƵ
#define FREQ_CHANGER_2_L 						0X80		//ɨƵ
#define FREQ_CHANGER_3_L 						0X00	    //ɨƵ
#define FREQ_CHANGER_1_H 						0X00		//ɨƵ
#define FREQ_CHANGER_2_H						0X02		//ɨƵ
#define FREQ_CHANGER_3_H						0X05		//ɨƵ
const unsigned char ucFreqChangerBaseL = FREQ_CHANGER_2_L;
const unsigned char ucFreqChangerBaseH = FREQ_CHANGER_2_H;
const unsigned char ucFreachooseLArray[3] = {
    FREQ_CHANGER_1_L,
    FREQ_CHANGER_2_L,
    FREQ_CHANGER_3_L
 };
 
const unsigned char ucFreachooseHArray[3] = {
    FREQ_CHANGER_1_H,
    FREQ_CHANGER_2_H,
    FREQ_CHANGER_3_H
};

/////////BANK л////////////////////////////////////////
#define 	BANKSEL4_7		MSCON1 |= 0X02;   //ӵַΪ 0x200~0x3FF
#define 	BANKSEL0_3		MSCON1 &= ~0X02; //ӵַΪ 0x000~0x1FF

////////͹Ķ///////////////////////////////////////////////////
//˯ģʽµĻ߸
#define SLEEP_MODE_BASE_LINE_COUNT   10   
const unsigned char ucSleepBaseLineCount = SLEEP_MODE_BASE_LINE_COUNT; 
//ٴް½͹,аһ
#define SLEEP_MODE_WAIT_NUMBER     250 
const unsigned char ucSleepModeWaitNumber = SLEEP_MODE_WAIT_NUMBER;
//͹״̬¿ŹƵ
#define SLEEP_RATE_SET0     0B00001111      // 1/4096
#define SLEEP_RATE_SET1     0B00010001      // 1/8192
const unsigned char ucSleepRateSet0 = SLEEP_RATE_SET0;
const unsigned char ucSleepRateSet1 = SLEEP_RATE_SET1;
//ÿ2sɨһΣô 2000/128 = 15
#define SLEEP_UPDATA_BASE_WAIT_NUMBER  15 
const unsigned char ucSleepUpdataBaseNumber = SLEEP_UPDATA_BASE_WAIT_NUMBER;
//͹İЧֵ
#define SLEEP_KEY_ON_VALUE    	 6// 8  
const unsigned char ucSleepKeyOnValue = SLEEP_KEY_ON_VALUE;
//͹İ
#define SLEEP_SCAN_KEY_GROUP     4  	 
const unsigned char ucSleepGroupMax = SLEEP_SCAN_KEY_GROUP;
//IO
#define TouchIoMaskA 0X07
#define TouchIoMaskB 0XFE
#define TouchIoMaskC 0XFF
#define TouchIoMaskD 0XFC
//
#define   SleepTrisAB_0	 	0x1800
#define   SleepTrisCD_0    	0x0000
#define   SleepTK01_0      	0x1800
#define   SleepTK23_0     	0x00C0
#define   SleepTrisAB_1	   	0x6000
#define   SleepTrisCD_1    	0x0000
#define   SleepTK01_1      	0x6000
#define   SleepTK23_1      	0x00C0
#define   SleepTrisAB_2	   	0x8000
#define   SleepTrisCD_2    	0x0001
#define   SleepTK01_2      	0x8001
#define   SleepTK23_2      	0x00C0
#define   SleepTrisAB_3	   	0x0001
#define   SleepTrisCD_3    	0x0002
#define   SleepTK01_3     	0x0006
#define   SleepTK23_3      	0x00C0
#define   SleepTrisAB_4	   	0x0000
#define   SleepTrisCD_4    	0x0000
#define   SleepTK01_4      	0x0000
#define   SleepTK23_4      	0x0000
#define   SleepTrisAB_5	   	0x0000
#define   SleepTrisCD_5    	0x0000
#define   SleepTK01_5      	0x0000
#define   SleepTK23_5      	0x0000
#define   SleepTrisAB_6	   	0x0000
#define   SleepTrisCD_6    	0x0000
#define   SleepTK01_6      	0x0000
#define   SleepTK23_6     	0x0000
#define   SleepTrisAB_7	   	0x0000
#define   SleepTrisCD_7    	0x0000
#define   SleepTK01_7      	0x0000
#define   SleepTK23_7      	0x0000
#define   SleepTrisAB_8	   	0x0000
#define   SleepTrisCD_8    	0x0000
#define   SleepTK01_8      	0x0000
#define   SleepTK23_8      	0x0000
#define   SleepTrisAB_9	   	0x0000
#define   SleepTrisCD_9    	0x0000
#define   SleepTK01_9      	0x0000
#define   SleepTK23_9      	0x0000
const unsigned char ucTouchIoMaskA = TouchIoMaskA;
const unsigned char ucTouchIoMaskB = TouchIoMaskB;
const unsigned char ucTouchIoMaskC = TouchIoMaskC;
const unsigned char ucTouchIoMaskD = TouchIoMaskD;
const unsigned int uiSleepTrisAB_0 	= SleepTrisAB_0;
const unsigned int uiSleepTrisCD_0 	= SleepTrisCD_0;
const unsigned int uiSleepTK01_0 	= SleepTK01_0;
const unsigned int uiSleepTK23_0 	= SleepTK23_0;
const unsigned int uiSleepTrisAB_1 	= SleepTrisAB_1;
const unsigned int uiSleepTrisCD_1 	= SleepTrisCD_1;
const unsigned int uiSleepTK01_1 	= SleepTK01_1;
const unsigned int uiSleepTK23_1 	= SleepTK23_1;
const unsigned int uiSleepTrisAB_2 	= SleepTrisAB_2;
const unsigned int uiSleepTrisCD_2 	= SleepTrisCD_2;
const unsigned int uiSleepTK01_2 	= SleepTK01_2;
const unsigned int uiSleepTK23_2 	= SleepTK23_2;
const unsigned int uiSleepTrisAB_3 	= SleepTrisAB_3;
const unsigned int uiSleepTrisCD_3 	= SleepTrisCD_3;
const unsigned int uiSleepTK01_3 	= SleepTK01_3;
const unsigned int uiSleepTK23_3 	= SleepTK23_3;  
const unsigned int uiSleepTrisAB_4 	= SleepTrisAB_4;
const unsigned int uiSleepTrisCD_4 	= SleepTrisCD_4;
const unsigned int uiSleepTK01_4 	= SleepTK01_4;
const unsigned int uiSleepTK23_4 	= SleepTK23_4;
const unsigned int uiSleepTrisAB_5 	= SleepTrisAB_5;
const unsigned int uiSleepTrisCD_5 	= SleepTrisCD_5;
const unsigned int uiSleepTK01_5  	= SleepTK01_5;
const unsigned int uiSleepTK23_5  	= SleepTK23_5;
const unsigned int uiSleepTrisAB_6 	= SleepTrisAB_6;
const unsigned int uiSleepTrisCD_6  = SleepTrisCD_6;
const unsigned int uiSleepTK01_6  	= SleepTK01_6;
const unsigned int uiSleepTK23_6  	= SleepTK23_6;
const unsigned int uiSleepTrisAB_7 	= SleepTrisAB_7;
const unsigned int uiSleepTrisCD_7 	= SleepTrisCD_7;
const unsigned int uiSleepTK01_7  	= SleepTK01_7;
const unsigned int uiSleepTK23_7 	= SleepTK23_7;
const unsigned int uiSleepTrisAB_8 	= SleepTrisAB_8;
const unsigned int uiSleepTrisCD_8 	= SleepTrisCD_8;
const unsigned int uiSleepTK01_8  	= SleepTK01_8;
const unsigned int uiSleepTK23_8 	= SleepTK23_8;
const unsigned int uiSleepTrisAB_9 	= SleepTrisAB_9;
const unsigned int uiSleepTrisCD_9 	= SleepTrisCD_9;
const unsigned int uiSleepTK01_9  	= SleepTK01_9;
const unsigned int uiSleepTK23_9 	= SleepTK23_9;
//ⲿ
extern volatile bit bSleepScanEnable;//͹ɨ账λ
extern volatile bit bSleepUserFlag; //ûʹ־ǷҪ͹״̬
extern volatile bit bSleepMode;//͹ı־λ
extern volatile bit bIEBackupsFlag;//͹ж˱־ıݱ־λ
extern volatile bit bSleepUserWakeFlag;//ûͨ־ǿ˳͹Ļ
//͹Ĺܺ
unsigned char TSC_SleepPrcoessing(void);//͹µĻѴ
////////͹Ķ///////////////////////////////////////////////////


///////////ܺ/////////////////////////////////////
void TOUCH_INITIAL(void);  //óʼ          
void TSC_Start(void); //ɨÿֻһһɨ账
void TSC_Reset(void); //λ. ʹ
unsigned char TSC_DataProcessing(void);//аݴ״̬: 1ʾаݴ 0ʾδ
unsigned char TSC_GetStrongest(void);  //ȡǿֵ
unsigned long TSC_GetSingle(void); //ȡЧ־ÿbitʾһ1Ϊа£0Ϊް
unsigned char TSC_GetDelta(unsigned char KeyNum); //ȡ仯, >󰴼KEY_NUMBERȡֵ 
unsigned int TSC_GetPrevData(unsigned char KeyNum); //ǰɼֵ

#endif
