//********************************************************* 
/* ļTEST_61F02x_SPI.c
* ܣ   FT61F02x-SPIʾ
* IC:      FT61F023 SOP16
*    16M/4T                    
* ˵   ʾΪ61F23x_SPIʾ.
*		   óȡ(25C64)0x12ֵַ,ȡ0x13ַ 
*
*                  FT61F023  SOP16 
*                 ----------------
*  VDD-----------|1(VDD)   (VSS)16|-----------GND     
*  CS------------|2(PA7)   (PA0)15|------------NC 
*  SCK-----------|3(PA6)   (PA1)14|------------NC
*  NC------------|4(PA5)   (PA2)13|----------MOSI
*  NC------------|5(PC3)   (PA3)12|------------NC
*  NC------------|6(PC2)   (PC0)11|------------NC
*  MISO----------|7(PA4)   (PC1)10|------------NC
*  NC------------|8(PC5)   (PC4)09|------------NC
*			      ----------------
*/
//*********************************************************
#include "SYSCFG.h"
//***********************궨****************************
#define  unchar     unsigned char 
#define  unint      unsigned int

#define  MISO		PA4   
#define  MOSI 		PA2
#define  SCK		PA6
#define  CS			PA7

unchar 	SPIReadData;
 /*-------------------------------------------------
* POWER_INITIAL
* ܣ  ϵϵͳʼ
* 룺  
*   
 --------------------------------------------------*/	
void POWER_INITIAL (void) 
{
	OSCCON = 0B01110001;			//IRCF=111=16MHz/4T=4MHz,0.25us
	INTCON = 0;  					//ݽֹж
    
	PORTA = 0B00000000;				
	TRISA = 0B00010000;				//PA 0- 1- PA4-
  	PORTC = 0B00000000; 	
	TRISC = 0B00000000;		        //PC 0- 1-  
    WPUA = 0B00010000;     			//PA˿ 1- 0-
    WPUC = 0B00000000;     			//PC˿ 1- 0-

	ANSEL = 0B00000000;
	OPTION = 0B00001000;			//Bit3=1,WDT MODE,PS=000=WDT RATE 1:1
    MSCKCON = 0B00000000;
    //Bit6->0,ֹPA4PC5ѹ
	//Bit5->0,TIMER2ʱΪFosc
	//Bit4->0,ֹLVR       
	CMCON0 = 0B00000111; 			//رձȽCxINΪIO
}

/*-------------------------------------------------
* init_25c64_io
* ܣ  25C64ʼ
* 룺  
*   
 --------------------------------------------------*/	
void init_25c64_io(void)
{
    CS = 1;
 	SCK = 0;
    MOSI = 0;
}
/*-------------------------------------------------
* SPI_RW
* ܣ  Լһֽ
* 룺  data
*   ݽյdataӻһֽ
 --------------------------------------------------*/		  
unchar SPI_RW(unchar data)
{
   unchar i; 
   for(i=0;i<8;i++)
   {
    if(data&0x80)
      MOSI = 1;
    else
      MOSI = 0;
    NOP();
    data<<=1;
    SCK  =  1;
	NOP();
    if(MISO)
      data  |= 0x01;
    else
      data  &= 0xFE;
	NOP();
    SCK  =  0;
   }
   return data;
 }
/*-------------------------------------------------
* WriteEnable
* ܣ  дWENλ 
 --------------------------------------------------*/
void WriteEnable(void)
{
    CS=0;
    SPI_RW(0x06);  
    CS=1;
}
/*-------------------------------------------------
* WriteDisable
* ܣ  дֹWENλ 
 --------------------------------------------------*/
 void WriteDisable (void)
{
    CS=0;
    SPI_RW(0x04);  
    CS=1;
}
/*------------------------------------------------
* SPI_ReadStatus
* ܣ  ȡ25C64оƬ״̬
* ֵ״̬Ĵֽ
* ע    25C64ڲ״̬Ĵ0λ=0ʾУ0λ=1ʾæ
--------------------------------------------------*/
unchar SPI_ReadStatus(void)
{
    unchar status=0;
    CS=0;
    SPI_RW(0x05);                 //0x05ȡ״̬
    status = SPI_RW(0x00);        
    CS=1;                         //رƬѡ
    return status;
}  
/*------------------------------------------------
* SPI_WriteStatus
* ܣ  д25C64оƬ״̬Ĵ
*         ֻBP1BP0 (bit732)д
* ע    25c64ڲ״̬Ĵ0λ=0ʾУ0λ=1ʾæ
--------------------------------------------------*/
void SPI_WriteStatus(unchar Status)
{
    CS=0;
    SPI_RW(0X01);  		          //0x01ȡ״̬
    SPI_RW(Status);               //дһֽ
    CS=1;                         //رƬѡ
}
/*-------------------------------------------------
* SPI_Read
* :   16λĵַ
* :   ȡ
* ˵  25c64ָĵַȡһֽ
---------------------------------------------------*/
unchar SPI_Read(unint addr)
{
	unchar spidata;
    while(SPI_ReadStatus()&0x01);       //жǷæ
    CS=0;                               //ʹ   
    SPI_RW(0x03);                       //Ͷȡ   
    SPI_RW((unsigned char)((addr)>>8));
    SPI_RW((unsigned char)addr);
  	spidata = SPI_RW(0x00);             //  
    CS=1;  
  	return spidata;            
}
/*----------------------------------------------------
* SPI_Write
* 룺  ַֽ
* ˵  һֽдָĵַ
------------------------------------------------------*/
void SPI_Write(unint addr,unchar dat)
{
    while(SPI_ReadStatus()&0x01);       //жǷæ
    WriteEnable();                      //λWEL
    CS=0;                               //ʹ   
    SPI_RW(0x02);   				    //д 
    SPI_RW((unchar)((addr)>>8));
    SPI_RW((unchar)addr);
    
    SPI_RW(dat);
    CS=1;                              //رƬѡ
	WriteDisable(); 
    while(SPI_ReadStatus()&0x01); 
}
/*-------------------------------------------------
* main 
* ܣ  
* 룺  
*   
 --------------------------------------------------*/
void main()
{
	POWER_INITIAL();				   //ϵͳʼ
	init_25c64_io();
	SPIReadData = SPI_Read(0x0012);    //ȡ0x12ַEEPROMֵ 
	SPI_Write(0x0013,~SPIReadData);    //ȡдַ0x13
	while(1)
	{
    	NOP();
	}
}
